<template>
  <div class="Slider">
    <div class="Slider-container">
      <button v-if="firstNotImage" class="Slider-nav" @click="prevImage">
        <div />
      </button>
      <ul :style="{ transform: `translateX(${-currentImage * 100}%) ` }">
        <li v-for="(image, idx) in images" :key="idx">
          <div>
            <img class="Slider-img" :src="image" />
          </div>
        </li>
      </ul>
      <button v-if="lastNotImage" class="Slider-nav right" @click="nextImage">
        <div />
      </button>
    </div>
  </div>
</template>

<script>
import invunerable from "../assets/invunerable.png";

const images = [invunerable, invunerable, invunerable];

export default {
  name: "Slider",
  data: () => ({
    currentImage: 0,
  }),
  computed: {
    firstNotImage() {
      return this.currentImage !== 0;
    },
    lastNotImage() {
      return this.currentImage < images.length - 1;
    },
    images() {
      return images;
    },
  },
  methods: {
    prevImage() {
      this.currentImage =
        (this.currentImage + images.length - 1) % images.length;
    },
    nextImage() {
      this.currentImage = (this.currentImage + 1) % images.length;
    },
  },
};
</script>

<style>
.Slider {
  position: relative;
  margin: 0 auto;
  overflow: hidden;
  z-index: 1;
}

.Slider-container {
  outline: 0;
  width: 100%;
  overflow: hidden;
  max-width: 1600px;
  margin: 0 auto;
}

.Slider-container ul {
  list-style: none;
  margin: 0;
  padding: 0;
  white-space: nowrap;
  overflow-x: visible;
  font-size: 0;
  transition: transform 0.5s;
}

.Slider-container ul > li {
  display: inline-block;
  max-width: 100%;
  width: 100%;
  font-size: 16px;
  top: 0;
  left: 0;
  position: relative;
  outline: none;
}

.Slider-nav {
  position: absolute;
  margin: 0;
  top: 0;
  left: 0;
  height: 100%;
  border: 0;
  padding: 6px !important;
  color: #fff;
  cursor: pointer;
  background: transparent;
  z-index: 10;
  filter: drop-shadow(0 0 5px #000);
}

.Slider-nav:hover {
  background: linear-gradient(270deg, transparent 0, rgba(17, 17, 17, 0.6));
}

.Slider-nav > div {
  width: 24px;
  height: 24px;
  border-top: 4px solid #fff;
  border-left: 4px solid #fff;
  border-radius: 4px;
  margin: 4px;
  transform: rotate(315deg);
}

.Slider-nav.right {
  left: auto;
  right: 0;
}

.Slider-nav.right > div {
  transform: rotate(135deg);
}

.Slider-nav.right:hover {
  background: linear-gradient(90deg, transparent 0, rgba(17, 17, 17, 0.6));
}

.Slider-img {
  max-height: 480px;
  width: 100%;
}
</style>
